#!/bin/sh
#file is gernetrated by gsl

g16_cpld_cpld_version()
{
###  get cpld_version reg 1 0x00 value
    regvalue_dec=$(/app/product -c -r 0x00 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x00 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x00 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x00"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x00] dec [%5s] hex [0x%4s] bin [%s]
" cpld_version $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpld_ver_l 15 0 "${regvalue_bin:$(expr $high_bit - 15):16}" "ro" "cpld version day."
###  get cpld_version reg 2 0x01 value
    regvalue_dec=$(/app/product -c -r 0x01 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x01 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x01 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x01"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x01] dec [%5s] hex [0x%4s] bin [%s]
" cpld_version $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpld_ver_h 15 0 "${regvalue_bin:$(expr $high_bit - 15):16}" "ro" "cpld version year and month"
}

g16_cpld_cpld_chip_id()
{
###  get cpld_chip_id reg 1 0x08 value
    regvalue_dec=$(/app/product -c -r 0x08 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x08 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x08 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x08"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x08] dec [%5s] hex [0x%4s] bin [%s]
" cpld_chip_id $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" chip_id 7 0 "${regvalue_bin:$(expr $high_bit - 7):8}" "ro" "cpld chipset id"
}

g16_cpld_cpld_test_bits()
{
###  get cpld_test_bits reg 1 0x0c value
    regvalue_dec=$(/app/product -c -r 0x0c |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x0c |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x0c |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x0c"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x0c] dec [%5s] hex [0x%4s] bin [%s]
" cpld_test_bits $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpld_test_regs 15 0 "${regvalue_bin:$(expr $high_bit - 15):16}" "rw" "test reg, will read reverse bit for set bits"
}

g16_cpld_sysinfo_contrl()
{
###  get sysinfo_contrl reg 1 0x10 value
    regvalue_dec=$(/app/product -c -r 0x10 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x10 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x10 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x10"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x10] dec [%5s] hex [0x%4s] bin [%s]
" sysinfo_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpld_refclk_locked 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "ro" "1: locked, 0: un-lock"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ifc_clk_locked 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "ro" "1: locked, 0: un-lock"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" bp_lc_insert 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "ro" "0: inserted, 1:not inserted"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" bp_to_lc_slotid_0 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" bp_to_lc_slotid_1 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" bp_to_lc_slotid_2 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" bp_to_lc_slotid_3 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" bp_to_lc_slotid_4 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "ro" ""
}

g16_cpld_pwr_manage()
{
###  get pwr_manage reg 1 0x11 value
    regvalue_dec=$(/app/product -c -r 0x11 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x11 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x11 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x11"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x11] dec [%5s] hex [0x%4s] bin [%s]
" pwr_manage $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sys_pwr_on 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" "0:pwr on 1:pwr down"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc1_to_lc_pwr_en 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "0:pwr on 1:pwr down"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_lc_pwr_en 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" "0:pwr on 1:pwr down"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_pwr_on 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "0:pwr on 1:pwr down"
}

g16_cpld_crosspoint()
{
###  get crosspoint reg 1 0x17 value
    regvalue_dec=$(/app/product -c -r 0x17 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x17 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x17 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x17"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x17] dec [%5s] hex [0x%4s] bin [%s]
" crosspoint $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" force_cr_sel 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "1:enable, 0:disable"
}

g16_cpld_sc_1p1()
{
###  get sc_1p1 reg 1 0x18 value
    regvalue_dec=$(/app/product -c -r 0x18 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x18 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x18 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x18"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x18] dec [%5s] hex [0x%4s] bin [%s]
" sc_1p1 $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" wpsel_local 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "1:sxc1 active, 0:sxc2 active"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc1_to_lc_wpsel 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" "1:active, 0:standby"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_lc_wpsel 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "ro" "1:active, 0:standby"
}

g16_cpld_watchdog()
{
###  get watchdog reg 1 0x20 value
    regvalue_dec=$(/app/product -c -r 0x20 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x20 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x20 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x20"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x20] dec [%5s] hex [0x%4s] bin [%s]
" watchdog $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" watchdog_expired_timer 15 4 "${regvalue_bin:$(expr $high_bit - 15):12}" "rw" "maxmum 2048 second"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" watchdog_expired_rst_timer 3 1 "${regvalue_bin:$(expr $high_bit - 3):3}" "rw" "maxmum 8"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" watchdog_enable 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "1: disable, 0: enable"
###  get watchdog reg 2 0x21 value
    regvalue_dec=$(/app/product -c -r 0x21 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x21 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x21 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x21"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x21] dec [%5s] hex [0x%4s] bin [%s]
" watchdog $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" watchdog_timer_cnt 15 4 "${regvalue_bin:$(expr $high_bit - 15):12}" "wc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" watchdog_expired_timer_cnt 3 0 "${regvalue_bin:$(expr $high_bit - 3):4}" "wc" ""
}

g16_cpld_cpu_reset()
{
###  get cpu_reset reg 1 0x30 value
    regvalue_dec=$(/app/product -c -r 0x30 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x30 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x30 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x30"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x30] dec [%5s] hex [0x%4s] bin [%s]
" cpu_reset $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_cold_rst_n 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "0: reset"
}

g16_cpld_chip_reset()
{
###  get chip_reset reg 1 0x31 value
    regvalue_dec=$(/app/product -c -r 0x31 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x31 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x31 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x31"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x31] dec [%5s] hex [0x%4s] bin [%s]
" chip_reset $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" reset_type_ind 5 3 "${regvalue_bin:$(expr $high_bit - 5):3}" "rw" "3:power,2:cold,1:watchdog,0:warm"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cop_sreset_n_dis 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" "1 mssked"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpu_reset_reqn_dis 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "1 mssked"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cop_chkstp_out_n_dis 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "1 mssked"
}

g16_cpld_chip_reset_cfg()
{
###  get chip_reset_cfg reg 1 0x32 value
    regvalue_dec=$(/app/product -c -r 0x32 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x32 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x32 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x32"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x32] dec [%5s] hex [0x%4s] bin [%s]
" chip_reset_cfg $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_mpl_sys_rst_l 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" "0: reset, 1: normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_bcm56450_reset_n 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" "0: reset, 1: normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_ip_pcie0_perst_n 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" "0: reset, 1: normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_ip_pcie1_perst_n 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" "0: reset, 1: normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_mpl_pcie_rst_n 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "0: reset, 1: normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_ds100_reset 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "1: reset, 0: normal"
}

g16_cpld_chip_reset_status()
{
###  get chip_reset_status reg 1 0x33 value
    regvalue_dec=$(/app/product -c -r 0x33 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x33 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x33 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x33"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x33] dec [%5s] hex [0x%4s] bin [%s]
" chip_reset_status $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" reset_req_n 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cop_chkstp_out_n 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cop_sreset_n 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cop_hreset_n 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" poreset_n 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" hreset_n 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" nor_reset_n 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ddr3_rst_l 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" mpl_sys_rst_l 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" bcm56450_reset_n 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ip_pcie0_perst_n 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ip_pcie1_perst_n 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" mpl_pcie_rst_n 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ds100_reset 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" "1: reset 0:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" wdg_rst_n 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "ro" "0: reset 1:normal"
}

g16_cpld_led_contrl()
{
###  get led_contrl reg 1 0x44 value
    regvalue_dec=$(/app/product -c -r 0x44 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x44 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x44 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x44"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x44] dec [%5s] hex [0x%4s] bin [%s]
" led_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ok_led_l 3 2 "${regvalue_bin:$(expr $high_bit - 3):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" fault_led_l 1 0 "${regvalue_bin:$(expr $high_bit - 1):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
###  get led_contrl reg 2 0x43 value
    regvalue_dec=$(/app/product -c -r 0x43 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x43 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x43 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x43"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x43] dec [%5s] hex [0x%4s] bin [%s]
" led_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon0_up 15 14 "${regvalue_bin:$(expr $high_bit - 15):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon0_down 13 12 "${regvalue_bin:$(expr $high_bit - 13):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon1_up 11 10 "${regvalue_bin:$(expr $high_bit - 11):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon1_down 9 8 "${regvalue_bin:$(expr $high_bit - 9):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon2_up 7 6 "${regvalue_bin:$(expr $high_bit - 7):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon2_down 5 4 "${regvalue_bin:$(expr $high_bit - 5):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon3_up 3 2 "${regvalue_bin:$(expr $high_bit - 3):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon3_down 1 0 "${regvalue_bin:$(expr $high_bit - 1):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
###  get led_contrl reg 3 0x42 value
    regvalue_dec=$(/app/product -c -r 0x42 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x42 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x42 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x42"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 3 [0x42] dec [%5s] hex [0x%4s] bin [%s]
" led_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon4_up 15 14 "${regvalue_bin:$(expr $high_bit - 15):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon4_down 13 12 "${regvalue_bin:$(expr $high_bit - 13):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon5_up 11 10 "${regvalue_bin:$(expr $high_bit - 11):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon5_down 9 8 "${regvalue_bin:$(expr $high_bit - 9):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon6_up 7 6 "${regvalue_bin:$(expr $high_bit - 7):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon6_down 5 4 "${regvalue_bin:$(expr $high_bit - 5):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon7_up 3 2 "${regvalue_bin:$(expr $high_bit - 3):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon7_down 1 0 "${regvalue_bin:$(expr $high_bit - 1):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
###  get led_contrl reg 4 0x41 value
    regvalue_dec=$(/app/product -c -r 0x41 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x41 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x41 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x41"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 4 [0x41] dec [%5s] hex [0x%4s] bin [%s]
" led_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon8_up 15 14 "${regvalue_bin:$(expr $high_bit - 15):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon8_down 13 12 "${regvalue_bin:$(expr $high_bit - 13):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon9_up 11 10 "${regvalue_bin:$(expr $high_bit - 11):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon9_down 9 8 "${regvalue_bin:$(expr $high_bit - 9):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon10_up 7 6 "${regvalue_bin:$(expr $high_bit - 7):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon10_down 5 4 "${regvalue_bin:$(expr $high_bit - 5):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon11_up 3 2 "${regvalue_bin:$(expr $high_bit - 3):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon11_down 1 0 "${regvalue_bin:$(expr $high_bit - 1):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
###  get led_contrl reg 5 0x40 value
    regvalue_dec=$(/app/product -c -r 0x40 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x40 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x40 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x40"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 5 [0x40] dec [%5s] hex [0x%4s] bin [%s]
" led_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon12_up 15 14 "${regvalue_bin:$(expr $high_bit - 15):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon12_down 13 12 "${regvalue_bin:$(expr $high_bit - 13):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon13_up 11 10 "${regvalue_bin:$(expr $high_bit - 11):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon13_down 9 8 "${regvalue_bin:$(expr $high_bit - 9):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon14_up 7 6 "${regvalue_bin:$(expr $high_bit - 7):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon14_down 5 4 "${regvalue_bin:$(expr $high_bit - 5):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon15_up 3 2 "${regvalue_bin:$(expr $high_bit - 3):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pon15_down 1 0 "${regvalue_bin:$(expr $high_bit - 1):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
}

g16_cpld_fan_contrl()
{
###  get fan_contrl reg 1 0x50 value
    regvalue_dec=$(/app/product -c -r 0x50 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x50 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x50 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x50"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x50] dec [%5s] hex [0x%4s] bin [%s]
" fan_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" topspeed 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" "1: topspeed, 0: normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lm75_os 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "0: over temperature, 1: normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" topspeed_en 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_topspeed 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "1: topspeed, 0: normal"
}

g16_cpld_sfp_contrl()
{
###  get sfp_contrl reg 1 0x60 value
    regvalue_dec=$(/app/product -c -r 0x60 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x60 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x60 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x60"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x60] dec [%5s] hex [0x%4s] bin [%s]
" sfp_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_0 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_1 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_2 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_3 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_4 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_5 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_6 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_7 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_8 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_9 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_10 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_11 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_12 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_13 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_14 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_15 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" ""
}

g16_cpld_sfp_alarm_control()
{
###  get sfp_alarm_control reg 1 0x63 value
    regvalue_dec=$(/app/product -c -r 0x63 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x63 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x63 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x63"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x63] dec [%5s] hex [0x%4s] bin [%s]
" sfp_alarm_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_0 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_1 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_2 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_3 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_4 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_5 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_6 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_7 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_8 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_9 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_10 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_11 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_12 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_13 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_14 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_los_15 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "1: enable, 0: disable"
###  get sfp_alarm_control reg 2 0x62 value
    regvalue_dec=$(/app/product -c -r 0x62 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x62 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x62 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x62"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x62] dec [%5s] hex [0x%4s] bin [%s]
" sfp_alarm_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_0 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_1 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_2 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_3 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_4 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_5 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_6 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_7 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_8 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_9 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_10 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_11 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_12 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_13 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_14 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txft_15 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "1: enable, 0: disable"
###  get sfp_alarm_control reg 3 0x61 value
    regvalue_dec=$(/app/product -c -r 0x61 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x61 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x61 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x61"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 3 [0x61] dec [%5s] hex [0x%4s] bin [%s]
" sfp_alarm_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_0 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_1 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_2 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_3 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_4 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_5 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_6 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_7 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_8 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_9 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_10 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_11 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_12 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_13 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_14 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_present_15 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "1: enable, 0: disable"
}

g16_cpld_cpld_version
g16_cpld_cpld_chip_id
g16_cpld_cpld_test_bits
g16_cpld_sysinfo_contrl
g16_cpld_pwr_manage
g16_cpld_crosspoint
g16_cpld_sc_1p1
g16_cpld_watchdog
g16_cpld_cpu_reset
g16_cpld_chip_reset
g16_cpld_chip_reset_cfg
g16_cpld_chip_reset_status
g16_cpld_led_contrl
g16_cpld_fan_contrl
g16_cpld_sfp_contrl
g16_cpld_sfp_alarm_control
printf "	%s
" "---------------------------------------------------------------------------------------------------"
#end of files generated
