

get_reg_info ()
{
    reg_addr=$1
    reg_value=$(/app/product -c -r $reg_addr | grep DEC | awk  '{print $2}')
    echo "$reg_value"
}


get_bit_offset()
{
    _value=$1
    _bit=$2
    let "bit_value=1<<$2"
    let "_value=_value&$bit_value"
    let "_value=_value>>$2"
    echo $_value
}



parse_SXC4_reg_0x10()
{
    reg_addr=0x10
    reg_value=$(get_reg_info $reg_addr)

    let "lower_8_bit_value=reg_value%8"
    let "high_8_bit_value=reg_vlaue/8"
    echo "get addr $reg_addr reg_value $reg_value high $high_8_bit_value low $lower_8_bit_value"

    value_BP_TYPE1=$(get_bit_offset $reg_value 11)
    value_BP_TYPE0=$(get_bit_offset $reg_value 10)
    value_CPLD_REFCLK_LOCKED=$(get_bit_offset $reg_value 9)
    value_IFC_CLK_LOCKED=$(get_bit_offset $reg_value 8)
    value_SXC1_TO_SXC2_PRESENT=$(get_bit_offset $reg_value 7)
    value_INSERT_1=$(get_bit_offset $reg_value 6)
    value_INSERT_0=$(get_bit_offset $reg_value 5)
    value_SLOTID_1=$(get_bit_offset $reg_value 4)
    value_SLOTID_0=$(get_bit_offset $reg_value 3)
    value_CARD_LATCH_ON=$(get_bit_offset $reg_value 2)
    value_SXC1_TO_SXC2_LATCH_OPEN=$(get_bit_offset $reg_value 1)
    value_SXC2_TO_SXC1_LATCH_OPEN=$(get_bit_offset $reg_value 0)
	
    printf "%28s : %s\n" "BP_TYPE1" "$value_BP_TYPE1"	
    printf "%28s : %s\n" "BP_TYPE0" "$value_BP_TYPE0"	
    printf "%28s : %s\n" "CPLD_REFCLK_LOCKED" "$value_CPLD_REFCLK_LOCKED"	
    printf "%28s : %s\n" "IFC_CLK_LOCKED" "$value_IFC_CLK_LOCKED"	
    printf "%28s : %s\n" "SXC1_TO_SXC2_PRESENT" "$value_SXC1_TO_SXC2_PRESENT"	
    printf "%28s : %s\n" "INSERT_1" "$value_INSERT_1"	
    printf "%28s : %s\n" "INSERT_0" "$value_INSERT_0"	
    printf "%28s : %s\n" "SLOTID_1" "$value_SLOTID_1"	
    printf "%28s : %s\n" "SLOTID_0" "$value_SLOTID_0"	
    printf "%28s : %s\n" "SXC1_TO_SXC2_LATCH_OPEN" "$value_SXC1_TO_SXC2_LATCH_OPEN"	
    printf "%28s : %s\n" "SXC2_TO_SXC1_LATCH_OPEN" "$value_SXC2_TO_SXC1_LATCH_OPEN"	
	return
}


parse_sxc4_reg_0x18()
{
    reg_addr=0x18
    reg_value=$(get_reg_info $reg_addr)

    let "lower_8_bit_value=reg_value%8"
    let "high_8_bit_value=reg_vlaue/8"
    echo "get addr $reg_addr reg_value $reg_value high $high_8_bit_value low $lower_8_bit_value"

    SXC2_TO_SXC1_WPSEL_STATUS=$(get_bit_offset $reg_value 4)
    LOCAL_WPSEL=$(get_bit_offset $reg_value 3)
    CFG_WPSEL_EN=$(get_bit_offset $reg_value 2)
    CFG_WPSEL=$(get_bit_offset $reg_value 1)
    WPSEL=$(get_bit_offset $reg_value 0)
	
    printf "%28s : %s\n" "SXC2_TO_SXC1_WPSEL_STATUS" "$SXC2_TO_SXC1_WPSEL_STATUS"	
    printf "%28s : %s\n" "LOCAL_WPSEL" "$LOCAL_WPSEL"	
    printf "%28s : %s\n" "CFG_WPSEL_EN" "$CFG_WPSEL_EN"	
    printf "%28s : %s\n" "CFG_WPSEL" "$CFG_WPSEL"	
    printf "%28s : %s\n" "WPSEL" "$WPSEL"	
	return
}

parse_sxc4_reg_0x19()
{
    reg_addr=0x19
    reg_value=$(get_reg_info $reg_addr)

    let "lower_8_bit_value=reg_value%8"
    let "high_8_bit_value=reg_vlaue/8"
    echo "get addr $reg_addr reg_value $reg_value high $high_8_bit_value low $lower_8_bit_value"

    wdog_to_SXC2_UF_en=$(get_bit_offset $reg_value 4)
    SXC1_TO_SXC2_UF2=$(get_bit_offset $reg_value 3)
    SXC2_TO_SXC1_PWRFAIL=$(get_bit_offset $reg_value 2)
    SXC2_TO_SXC1_LATCH_OPEN=$(get_bit_offset $reg_value 1)
    SXC2_TO_SXC1_UF2=$(get_bit_offset $reg_value 0)
	
    printf "%28s : %s\n" "wdog_to_SXC2_UF_en" "$wdog_to_SXC2_UF_en"	
    printf "%28s : %s\n" "SXC1_TO_SXC2_UF2" "$SXC1_TO_SXC2_UF2"	
    printf "%28s : %s\n" "SXC2_TO_SXC1_PWRFAIL" "$SXC2_TO_SXC1_PWRFAIL"	
    printf "%28s : %s\n" "SXC2_TO_SXC1_LATCH_OPEN" "$SXC2_TO_SXC1_LATCH_OPEN"	
    printf "%28s : %s\n" "SXC2_TO_SXC1_UF2" "$SXC2_TO_SXC1_UF2"	
	return
}
echo -e
parse_SXC4_reg_0x10
echo -e
parse_sxc4_reg_0x18
echo -e
parse_sxc4_reg_0x19
