#!/bin/sh
#file is gernetrated by gsl

sxc4_cpld_cpld_version()
{
###  get cpld_version reg 1 0x00 value
    regvalue_dec=$(/app/product -c -r 0x00 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x00 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x00 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x00"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x00] dec [%5s] hex [0x%4s] bin [%s]
" cpld_version $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpld_ver_l 15 0 "${regvalue_bin:$(expr $high_bit - 15):16}" "ro" "cpld version day."
###  get cpld_version reg 2 0x01 value
    regvalue_dec=$(/app/product -c -r 0x01 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x01 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x01 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x01"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x01] dec [%5s] hex [0x%4s] bin [%s]
" cpld_version $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpld_ver_h 15 0 "${regvalue_bin:$(expr $high_bit - 15):16}" "ro" "cpld version year and month"
}

sxc4_cpld_cpld_chip_id()
{
###  get cpld_chip_id reg 1 0x08 value
    regvalue_dec=$(/app/product -c -r 0x08 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x08 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x08 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x08"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x08] dec [%5s] hex [0x%4s] bin [%s]
" cpld_chip_id $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" chip_id 7 0 "${regvalue_bin:$(expr $high_bit - 7):8}" "ro" "cpld chipset id"
}

sxc4_cpld_cpld_test_bits()
{
###  get cpld_test_bits reg 1 0x0c value
    regvalue_dec=$(/app/product -c -r 0x0c |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x0c |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x0c |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x0c"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x0c] dec [%5s] hex [0x%4s] bin [%s]
" cpld_test_bits $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpld_test_regs 15 0 "${regvalue_bin:$(expr $high_bit - 15):16}" "rw" "test reg, will read reverse bit for set bits"
}

sxc4_cpld_sysinfo_contrl()
{
###  get sysinfo_contrl reg 1 0x10 value
    regvalue_dec=$(/app/product -c -r 0x10 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x10 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x10 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x10"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x10] dec [%5s] hex [0x%4s] bin [%s]
" sysinfo_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" backpane_type 11 10 "${regvalue_bin:$(expr $high_bit - 11):2}" "ro" "backpane type. value 0x10:10u 0x01:5u"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpld_refclk_locked 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "ro" "cpld refclk locked"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ifc_clk_locked 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "ro" "ifc_clk_locked"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc1_to_sxc2_present 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "ro" "sxc1_to_sxc2_present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" insert 6 5 "${regvalue_bin:$(expr $high_bit - 6):2}" "ro" "insert"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" slotid 4 3 "${regvalue_bin:$(expr $high_bit - 4):2}" "ro" "slotid"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" card_latch_on 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "card_latch_on"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc1_to_sxc2_latch_open 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" "sxc1_to_sxc2_latch_open"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_sxc1_latch_open 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "ro" "sxc2_to_sxc1_latch_open"
}

sxc4_cpld_sc_1p1()
{
###  get sc_1p1 reg 1 0x18 value
    regvalue_dec=$(/app/product -c -r 0x18 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x18 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x18 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x18"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x18] dec [%5s] hex [0x%4s] bin [%s]
" sc_1p1 $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_sxc1_wpsel_status 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "ro" "sxc2_to_sxc1_wpsel_status"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" local_wpsel 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" "local_wpsel"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_wpsel_en 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" "cfg_wpsel_en"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_wpsel 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "cfg_wpsel"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" wpsel 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "wpsel"
}

sxc4_cpld_sc_failure_control()
{
###  get sc_failure_control reg 1 0x19 value
    regvalue_dec=$(/app/product -c -r 0x19 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x19 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x19 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x19"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x19] dec [%5s] hex [0x%4s] bin [%s]
" sc_failure_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc1_to_sxc2_uf2 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" "sxc1_to_sxc2_uf2"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_sxc1_pwrfail 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "sxc2_to_sxc1_pwrfail"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_sxc1_latch_open 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" "sxc2_to_sxc1_latch_open"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_sxc1_uf2 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "ro" "sxc2_to_sxc1_uf2"
}

sxc4_cpld_slot_pwr_contrl()
{
###  get slot_pwr_contrl reg 1 0x1a value
    regvalue_dec=$(/app/product -c -r 0x1a |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x1a |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x1a |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x1a"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x1a] dec [%5s] hex [0x%4s] bin [%s]
" slot_pwr_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc1_pwren 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rw" "sxc_to_lc1_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc2_pwren 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rw" "sxc_to_lc2_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc3_pwren 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rw" "sxc_to_lc3_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc4_pwren 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rw" "sxc_to_lc4_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc5_pwren 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rw" "sxc_to_lc5_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc6_pwren 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rw" "sxc_to_lc6_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc7_pwren 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rw" "sxc_to_lc7_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc8_pwren 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rw" "sxc_to_lc8_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc9_pwren 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rw" "sxc_to_lc9_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc10_pwren 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rw" "sxc_to_lc10_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc11_pwren 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" "sxc_to_lc11_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc12_pwren 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" "sxc_to_lc12_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc13_pwren 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" "sxc_to_lc13_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_lc14_pwren 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" "sxc_to_lc14_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_upl1_pwren 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "sxc_to_upl1_pwren"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_upl2_pwren 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "sxc_to_upl2_pwren"
}

sxc4_cpld_chip_others()
{
###  get chip_others reg 1 0x1b value
    regvalue_dec=$(/app/product -c -r 0x1b |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x1b |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x1b |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x1b"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x1b] dec [%5s] hex [0x%4s] bin [%s]
" chip_others $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpld_lamptest_ctr 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rw" "cpld_lamptest_ctr"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pwr1_to_sxcg_pmon 8 7 "${regvalue_bin:$(expr $high_bit - 8):2}" "ro" "pwr1_to_sxcg_pmon"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pwr2_to_sxcg_pmon 6 5 "${regvalue_bin:$(expr $high_bit - 6):2}" "ro" "pwr2_to_sxcg_pmon"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" fan_to_sxcg_fan_alarm 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "ro" "fan_to_sxcg_fan_alarm"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc_to_fan_los 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" "sxc_to_fan_los"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pca9514_i2c4_en 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "pca9514_i2c4_en"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_pca9514_i2c4_en 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "cfg_pca9514_i2c4_en"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_pca9514_i2c4 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "cfg_pca9514_i2c4"
}

sxc4_cpld_watchdog()
{
###  get watchdog reg 1 0x20 value
    regvalue_dec=$(/app/product -c -r 0x20 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x20 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x20 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x20"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x20] dec [%5s] hex [0x%4s] bin [%s]
" watchdog $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" watchdog_expired_timer 15 4 "${regvalue_bin:$(expr $high_bit - 15):12}" "rw" "maxmum 2048 second"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" watchdog_expired_rst_timer 3 1 "${regvalue_bin:$(expr $high_bit - 3):3}" "rw" "maxmum 8"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" watchdog_enable 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "1: disable, 0: enable"
###  get watchdog reg 2 0x21 value
    regvalue_dec=$(/app/product -c -r 0x21 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x21 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x21 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x21"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x21] dec [%5s] hex [0x%4s] bin [%s]
" watchdog $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" watchdog_timer_cnt 15 4 "${regvalue_bin:$(expr $high_bit - 15):12}" "wc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" watchdog_expired_timer_cnt 3 0 "${regvalue_bin:$(expr $high_bit - 3):4}" "wc" ""
}

sxc4_cpld_cpu_reset()
{
###  get cpu_reset reg 1 0x30 value
    regvalue_dec=$(/app/product -c -r 0x30 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x30 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x30 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x30"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x30] dec [%5s] hex [0x%4s] bin [%s]
" cpu_reset $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_cold_rst_n 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "0: reset"
}

sxc4_cpld_chip_reset()
{
###  get chip_reset reg 1 0x31 value
    regvalue_dec=$(/app/product -c -r 0x31 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x31 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x31 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x31"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x31] dec [%5s] hex [0x%4s] bin [%s]
" chip_reset $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cop_sreset_n_dis 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cpu_reset_reqn_dis 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cop_chkstp_out_n_dis 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" ""
}

sxc4_cpld_bcm_reset()
{
###  get bcm_reset reg 1 0x32 value
    regvalue_dec=$(/app/product -c -r 0x32 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x32 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x32 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x32"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x32] dec [%5s] hex [0x%4s] bin [%s]
" bcm_reset $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_bcm5396_rst 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_bcm56844_reset_n 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_bcm5482s_reset 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" ""
}

sxc4_cpld_chip_reset_status()
{
###  get chip_reset_status reg 1 0x33 value
    regvalue_dec=$(/app/product -c -r 0x33 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x33 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x33 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x33"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x33] dec [%5s] hex [0x%4s] bin [%s]
" chip_reset_status $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" reset_req_n 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cop_chkstp_out_n 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cop_sreset_n 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cop_hreset_n 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" poreset_n 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" hreset_n 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" nor_reset_n 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" bcm5396_rst 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" bcm56844_reset_n 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" bcm5482s_reset 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" "0: reset 1:normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" wdg_rst_n 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "ro" "0: reset 1:normal"
}

sxc4_cpld_led_contrl()
{
###  get led_contrl reg 1 0x40 value
    regvalue_dec=$(/app/product -c -r 0x40 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x40 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x40 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x40"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x40] dec [%5s] hex [0x%4s] bin [%s]
" led_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp1_link_led 15 14 "${regvalue_bin:$(expr $high_bit - 15):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp2_link_led 13 12 "${regvalue_bin:$(expr $high_bit - 13):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp3_link_led 11 10 "${regvalue_bin:$(expr $high_bit - 11):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp4_link_led 9 8 "${regvalue_bin:$(expr $high_bit - 9):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp5_link_led 7 6 "${regvalue_bin:$(expr $high_bit - 7):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp6_link_led 5 4 "${regvalue_bin:$(expr $high_bit - 5):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp7_link_led 3 2 "${regvalue_bin:$(expr $high_bit - 3):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp8_link_led 1 0 "${regvalue_bin:$(expr $high_bit - 1):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
###  get led_contrl reg 2 0x41 value
    regvalue_dec=$(/app/product -c -r 0x41 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x41 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x41 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x41"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x41] dec [%5s] hex [0x%4s] bin [%s]
" led_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" run_led    5 4 "${regvalue_bin:$(expr $high_bit - 5):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" active_led 3 2 "${regvalue_bin:$(expr $high_bit - 3):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" fault_led  1 0 "${regvalue_bin:$(expr $high_bit - 1):2}" "rw" "0：led_on 1：led_off 2：blink_fast 3：blink_slow"
}

sxc4_cpld_fan_contrl()
{
###  get fan_contrl reg 1 0x50 value
    regvalue_dec=$(/app/product -c -r 0x50 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x50 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x50 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x50"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x50] dec [%5s] hex [0x%4s] bin [%s]
" fan_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" topspeed 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" "1: topspeed, 0: normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lm75_os 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "0: over temperature, 1: normal"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" topspeed_en 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "1: enable, 0: disable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" cfg_topspeed 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "1: topspeed, 0: normal"
}

sxc4_cpld_sfp_contrl()
{
###  get sfp_contrl reg 1 0x60 value
    regvalue_dec=$(/app/product -c -r 0x60 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x60 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x60 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x60"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x60] dec [%5s] hex [0x%4s] bin [%s]
" sfp_contrl $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_0 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_1 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_2 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_3 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_4 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_5 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_6 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_txdisable_7 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_rs1_0 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_rs1_1 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_rs1_2 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_rs1_3 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_rs1_4 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_rs1_5 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_rs1_6 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_rs1_7 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" ""
}

sxc4_cpld_sfp_alarm_control()
{
###  get sfp_alarm_control reg 1 0x61 value
    regvalue_dec=$(/app/product -c -r 0x61 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x61 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x61 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x61"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x61] dec [%5s] hex [0x%4s] bin [%s]
" sfp_alarm_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_txft_0 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_txft_1 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_txft_2 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_txft_3 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_txft_4 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_txft_5 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_txft_6 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_txft_7 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_present_0 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_present_1 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_present_2 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_present_3 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_present_4 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_present_5 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_present_6 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_present_7 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "alarm interupt enable, 1: enable"
###  get sfp_alarm_control reg 2 0x62 value
    regvalue_dec=$(/app/product -c -r 0x62 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x62 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x62 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x62"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x62] dec [%5s] hex [0x%4s] bin [%s]
" sfp_alarm_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_los_0 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_los_1 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_los_2 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_los_3 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_los_4 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_los_5 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_los_6 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" "alarm interupt enable, 1: enable"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_int_en_sfp_los_7 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" "alarm interupt enable, 1: enable"
###  get sfp_alarm_control reg 3 0x64 value
    regvalue_dec=$(/app/product -c -r 0x64 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x64 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x64 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x64"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 3 [0x64] dec [%5s] hex [0x%4s] bin [%s]
" sfp_alarm_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_los_0 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_los_1 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_los_2 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_los_3 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_los_4 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_los_5 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_los_6 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_los_7 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_txft_0 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_txft_1 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_txft_2 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_txft_3 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_txft_4 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_txft_5 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_txft_6 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_txft_7 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "ro" ""
###  get sfp_alarm_control reg 4 0x65 value
    regvalue_dec=$(/app/product -c -r 0x65 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x65 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x65 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x65"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 4 [0x65] dec [%5s] hex [0x%4s] bin [%s]
" sfp_alarm_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_present_0 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_present_1 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_present_2 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_present_3 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_present_4 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_present_5 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_present_6 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" alarm_sfp_present_7 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "ro" ""
###  get sfp_alarm_control reg 5 0x67 value
    regvalue_dec=$(/app/product -c -r 0x67 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x67 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x67 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x67"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 5 [0x67] dec [%5s] hex [0x%4s] bin [%s]
" sfp_alarm_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_los_0 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_los_1 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_los_2 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_los_3 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_los_4 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_los_5 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_los_6 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_los_7 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_txft_0 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_txft_1 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_txft_2 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_txft_3 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_txft_4 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_txft_5 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_txft_6 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_txft_7 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rwc" ""
###  get sfp_alarm_control reg 6 0x68 value
    regvalue_dec=$(/app/product -c -r 0x68 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x68 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x68 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x68"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 6 [0x68] dec [%5s] hex [0x%4s] bin [%s]
" sfp_alarm_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_present_0 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_present_1 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_present_2 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_present_3 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_present_4 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_present_5 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_present_6 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rwc" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" history_alarm_sfp_present_7 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rwc" ""
###  get sfp_alarm_control reg 7 0x70 value
    regvalue_dec=$(/app/product -c -r 0x70 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x70 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x70 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x70"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 7 [0x70] dec [%5s] hex [0x%4s] bin [%s]
" sfp_alarm_control $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" i2c_port 3 0 "${regvalue_bin:$(expr $high_bit - 3):4}" "rw" "0~7：sfp_i2c_0~sfp_i2c_7 8：sxc_to_lcg1_i2c 9：sxc_to_lcg2_i2c 10：sxc_to_fan_i2c 11：sxc_to_pwrg_i2c 12：sxc_to_upl1_i2c 13：sxc_to_upl2_i2c"
}

sxc4_cpld_slot_present_interupt_enable()
{
###  get slot_present_interupt_enable reg 1 0x90 value
    regvalue_dec=$(/app/product -c -r 0x90 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x90 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x90 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x90"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x90] dec [%5s] hex [0x%4s] bin [%s]
" slot_present_interupt_enable $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc5_to_sxcg_present 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc6_to_sxcg_present 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc7_to_sxcg_present 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc8_to_sxcg_present 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc9_to_sxcg_present 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc10_to_sxcg_present 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc11_to_sxcg_present 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc12_to_sxcg_present 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc13_to_sxcg_present 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc14_to_sxcg_present 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_upl1_to_sxcg_present 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_upl2_to_sxcg_present 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_pwr1_to_sxcg_present 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_pwr2_to_sxcg_present 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_fan_to_sxcg_present 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_sxc2_to_sxc1_present 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" ""
###  get slot_present_interupt_enable reg 2 0x91 value
    regvalue_dec=$(/app/product -c -r 0x91 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x91 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x91 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x91"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x91] dec [%5s] hex [0x%4s] bin [%s]
" slot_present_interupt_enable $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc1_to_sxcg_present 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc2_to_sxcg_present 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc3_to_sxcg_present 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_en_lc4_to_sxcg_present 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" ""
}

sxc4_cpld_slot_present_status()
{
###  get slot_present_status reg 1 0x92 value
    regvalue_dec=$(/app/product -c -r 0x92 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x92 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x92 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x92"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x92] dec [%5s] hex [0x%4s] bin [%s]
" slot_present_status $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc5_to_sxcg_present 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc6_to_sxcg_present 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc7_to_sxcg_present 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc8_to_sxcg_present 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc9_to_sxcg_present 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc10_to_sxcg_present 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc11_to_sxcg_present 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc12_to_sxcg_present 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc13_to_sxcg_present 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc14_to_sxcg_present 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" upl1_to_sxcg_present 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" upl2_to_sxcg_present 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pwr1_to_sxcg_present 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pwr2_to_sxcg_present 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" fan_to_sxcg_present 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_sxc1_present 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "ro" "1:absent 0:present"
###  get slot_present_status reg 2 0x93 value
    regvalue_dec=$(/app/product -c -r 0x93 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x93 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x93 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x93"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x93] dec [%5s] hex [0x%4s] bin [%s]
" slot_present_status $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc1_to_sxcg_present 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc2_to_sxcg_present 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc3_to_sxcg_present 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "ro" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" lc4_to_sxcg_present 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "ro" "1:absent 0:present"
}

sxc4_cpld_slot_present_interupt_status()
{
###  get slot_present_interupt_status reg 1 0x94 value
    regvalue_dec=$(/app/product -c -r 0x94 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x94 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x94 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x94"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0x94] dec [%5s] hex [0x%4s] bin [%s]
" slot_present_interupt_status $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc5_to_sxcg_present 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc6_to_sxcg_present 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc7_to_sxcg_present 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc8_to_sxcg_present 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc9_to_sxcg_present 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc10_to_sxcg_present 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc11_to_sxcg_present 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc12_to_sxcg_present 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc13_to_sxcg_present 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc14_to_sxcg_present 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_upl1_to_sxcg_present 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_upl2_to_sxcg_present 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_pwr1_to_sxcg_present 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_pwr2_to_sxcg_present 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_fan_to_sxcg_present 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_sxc2_to_sxc1_present 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rwc" "1:absent 0:present"
###  get slot_present_interupt_status reg 2 0x95 value
    regvalue_dec=$(/app/product -c -r 0x95 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0x95 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0x95 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0x95"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0x95] dec [%5s] hex [0x%4s] bin [%s]
" slot_present_interupt_status $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc1_to_sxcg_present 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc2_to_sxcg_present 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc3_to_sxcg_present 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rwc" "1:absent 0:present"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" int_lc4_to_sxcg_present 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rwc" "1:absent 0:present"
}

sxc4_cpld_interupt()
{
###  get interupt reg 1 0xf0 value
    regvalue_dec=$(/app/product -c -r 0xf0 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0xf0 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0xf0 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0xf0"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 1 [0xf0] dec [%5s] hex [0x%4s] bin [%s]
" interupt $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" t1024_irq4 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" t1024_irq1 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" t1024_irq0 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" ""
###  get interupt reg 2 0xf1 value
    regvalue_dec=$(/app/product -c -r 0xf1 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0xf1 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0xf1 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0xf1"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 2 [0xf1] dec [%5s] hex [0x%4s] bin [%s]
" interupt $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc1_to_sxc2_latch_open_int 15 15 "${regvalue_bin:$(expr $high_bit - 15):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ~upl1_to_sxc1_rsv_1 14 14 "${regvalue_bin:$(expr $high_bit - 14):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ~upl2_to_sxc1_rsv_1 13 13 "${regvalue_bin:$(expr $high_bit - 13):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ~lm75_os 12 12 "${regvalue_bin:$(expr $high_bit - 12):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sfp_int 11 11 "${regvalue_bin:$(expr $high_bit - 11):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_sxc1_present 10 10 "${regvalue_bin:$(expr $high_bit - 10):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_sxc1_pwrfail 9 9 "${regvalue_bin:$(expr $high_bit - 9):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_sxc1_latch_open 8 8 "${regvalue_bin:$(expr $high_bit - 8):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" sxc2_to_sxc1_uf2 7 7 "${regvalue_bin:$(expr $high_bit - 7):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" slot_present_int 6 6 "${regvalue_bin:$(expr $high_bit - 6):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pwr1_to_sxcg_pmon_1 5 5 "${regvalue_bin:$(expr $high_bit - 5):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pwr1_to_sxcg_pmon_2 4 4 "${regvalue_bin:$(expr $high_bit - 4):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pwr2_to_sxcg_pmon_1 3 3 "${regvalue_bin:$(expr $high_bit - 3):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" pwr2_to_sxcg_pmon_2 2 2 "${regvalue_bin:$(expr $high_bit - 2):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" fan_to_sxcg_fan_alarm 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" clk_1hz 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" ""
###  get interupt reg 3 0xf2 value
    regvalue_dec=$(/app/product -c -r 0xf2 |awk '/DEC:/{print $2}')
    regvalue_hex=$(/app/product -c -r 0xf2 |awk '/DEC:/{printf "%04x",$2}')
    regvalue_bin=$(/app/product -c -r 0xf2 |awk '/BIN:/{print $2 $3}')
    if [ ${#regvalue_bin} -eq 16 ]; then
        high_bit=15
    elif [ ${#regvalue_bin} -eq 8 ]; then
        high_bit=7
    else
        echo "failed to get binary value for reg 0xf2"
    fi
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
	printf "
"
    printf " %-30s index 3 [0xf2] dec [%5s] hex [0x%4s] bin [%s]
" interupt $regvalue_dec	$regvalue_hex $regvalue_bin
    printf "	%s
" "---------------------------------------------------------------------------------------------------"
    printf "	|%-30s | %5s | %16s | %-4s| %-30s |
" "        name" "bits" "  value"  "type"  "  description"
	printf "	%s
" "---------------------------------------------------------------------------------------------------"
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ~cpld_refclk_locked 1 1 "${regvalue_bin:$(expr $high_bit - 1):1}" "rw" ""
#### get component reg value
    printf "	|%-30s | %02d:%02d | %16s | %-3s | %-30s |
" ~ifc_clk_locked 0 0 "${regvalue_bin:$(expr $high_bit - 0):1}" "rw" ""
}

sxc4_cpld_cpld_version
sxc4_cpld_cpld_chip_id
sxc4_cpld_cpld_test_bits
sxc4_cpld_sysinfo_contrl
sxc4_cpld_sc_1p1
sxc4_cpld_sc_failure_control
sxc4_cpld_slot_pwr_contrl
sxc4_cpld_chip_others
sxc4_cpld_watchdog
sxc4_cpld_cpu_reset
sxc4_cpld_chip_reset
sxc4_cpld_bcm_reset
sxc4_cpld_chip_reset_status
sxc4_cpld_led_contrl
sxc4_cpld_fan_contrl
sxc4_cpld_sfp_contrl
sxc4_cpld_sfp_alarm_control
sxc4_cpld_slot_present_interupt_enable
sxc4_cpld_slot_present_status
sxc4_cpld_slot_present_interupt_status
sxc4_cpld_interupt
printf "	%s
" "---------------------------------------------------------------------------------------------------"
#end of files generated
